Add-Type -TypeDefinition @"
using System;
using System.IO;
using System.Threading;
using System.Diagnostics;
using System.Runtime.InteropServices;

namespace A {
	public class B {
		[StructLayout(LayoutKind.Sequential)]
		private struct FILETIME {
			public UInt32 dwLow;
			public UInt32 dwHigh;
		}

		[DllImport("kernel32.dll")]
		private static extern bool QueryPerformanceCounter(out long lpCount);

		[DllImport("kernel32.dll")]
		private static extern bool QueryPerformanceFrequency(out long lpFreq);

		[DllImport("kernel32.dll")]
		private static extern void GetSystemTimeAsFileTime(ref FILETIME ft);

		double[] times() {
			long a, b;
			if (!QueryPerformanceCounter(out a)) {
				Console.WriteLine("[x] getctr");
				return null;
			}
			if (!QueryPerformanceFrequency(out b)) {
				Console.WriteLine("[x] getfreq");
				return null;
			}
			while (b > 1000) {
				a /= 10;
				b /= 10;
			}
			double tick = (double)a / (double)b;

			FILETIME ft = new FILETIME();
			GetSystemTimeAsFileTime(ref ft);
			UInt64 lft = (((UInt64)ft.dwHigh) << 32) + ft.dwLow;
			lft /= 10ul * 1000ul;
			double dft = (double)lft / 1000;

			return new double[] { tick, dft };
		}

		void _run() {
			double[] t0 = times();
			while (true) {
				System.Threading.Thread.Sleep(1000);
				double[] t = times();
				double eperf = t[0] - t0[0];
				double ewall = t[1] - t0[1];
				Console.WriteLine(
					"{0:0.000}  {1:0.000}  {2:0.000}  {3:0.000}",
					eperf, ewall, 1800-eperf, 1800-ewall);
			}			
		}

		public void Run() {
			Console.WriteLine("[+] hi");
			new Thread(_run).Start();
			Console.ReadLine();
			Console.WriteLine("[+] bye");
		}
	}
}
"@ 

(New-Object -TypeName A.B).Run()

# ctrl-shift powershell
# set-executionPolicy unrestricted -force
